//+------------------------------------------------------------------+
//|                                   $_Danglin_Multi_Strategy_2.mq4 |
//|                                  Copyright  2008, Delroy Anglin |
//|                                               danglin462@aol.com |
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Delroy Anglin"
#property link      "danglin462@aol.com"

#property indicator_separate_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1

extern int price.x.offset= 0;//250
extern int price.y.offset= 10;//-160
extern bool my.alert.sound = true ;


color ColorValuesLowestLow;
color ColorValuesSLLong;
color ColorValuesSLShort;
color ColorValuesHighestHigh;
color ColorValuesLowestSLLong;
color ColorValuesLowestSLShort;



//danglin Pivot Point MA _MOMENTUM
extern bool use.momentum      = true ;
double      PriceMomentum;
string      pAlertMomentum;
string      tAlertMomentum;
color       ColorValuesMomentum;
color       colorArrowMomentum;
bool        LgTriggerMomentum;
bool        ShTriggerMomentum;
string      ArrowMomentum;


//EURO BREAKOUT
extern bool use.EURO     = false ;
double      PriceEURO ; 
string      pAlertEURO;
string      tAlertEURO; 
color       ColorValuesEURO ;
bool        ShTriggerEURO; 
bool        LgTriggerEURO;
string      ArrowEURO  ;  
color       colorArrowEURO  ; 

//LONDON MOMENTUM
extern bool use.LONDON     = false ;
double      PriceLONDON ; 
string      pAlertLONDON;
string      tAlertLONDON; 
color       ColorValuesLONDON ;
bool        ShTriggerLONDON; 
bool        LgTriggerLONDON;
string      ArrowLONDON  ;  
color       colorArrowLONDON  ; 

//CASHCOW
extern bool use.CashCow      = false ;
double      PriceCC;
string      pAlertCC;
string      tAlertCC;
color       ColorValuesCC;
color       colorArrowCC;
bool        ShTriggerCC;
bool        LgTriggerCC;
string      ArrowCC;
 
//ASSASSIN
extern bool use.ASSASSIN     = true ;
double      PriceASSASSIN ; 
string      pAlertASSASSIN;
string      tAlertASSASSIN; 
color       ColorValuesASSASSIN ;
bool        ShTriggerASSASSIN; 
bool        LgTriggerASSASSIN;
string      ArrowASSASSIN  ;  
color       colorArrowASSASSIN  ; 


//INSIDE BAR
extern bool use.IB     = true ;
double      PriceIB ; 
string      pAlertIB; 
string      tAlertIB; 
color       ColorValuesIB ;
bool        ShTriggerIB; 
bool        LgTriggerIB;
string      ArrowIB ;  
color       colorArrowIB  ; 

//DANGLIN M15 Reversal Scalper
extern bool use.scalp      = true ;
extern int FastEMA = 8;
extern int SlowEMA = 17;
extern int SignalSMA = 9;
double      Pricescalp;
string      pAlertscalp;
string      tAlertscalp;
color       ColorValuesscalp;
color       colorArrowscalp;
bool        ShTriggerscalp;
bool        LgTriggerscalp;
string      Arrowscalp;

//H1 Reversal Scalper
extern bool use.H1Rev      = true ;
double      PriceH1Rev;
string      pAlertH1Rev;
string      tAlertH1Rev;
color       ColorValuesH1Rev;
color       colorArrowH1Rev;
bool        ShTriggerH1Rev;
bool        LgTriggerH1Rev;
string      ArrowH1Rev;


//----------------------------
//CUSTOM VARIABLE DECLARATION
//-----------------------------
//for H4 Reversal
extern double myRange = 9 ;
double M5Close;
double M5Open;
double M30High;
double M30Low;
double M30Close;
double M30Open;
double M15Close;
double M15Open;
double H4Close;
double H4Open;
double H1Close;
double H1Open;
double D1Open;
double D1Close;
double D1High;
double D1Low;
double H4stochmain;
double cH4stochmain;
double cD1RSI2;
double cD1RSI4;
double cH4RSI2;
double cH4RSI4;
double H4RSI2;
double H4RSI4;
double cH1RSI2;
double cH1RSI4;
double H1RSI2;
double H1RSI4;
double cH1CCI;
double H1CCI;
double cM15RSI2;
double cM15RSI4;
double cM15CCI;
double M15CCI;
double close;
double open;
double M30Bar3Hi;
double M30Bar3Lo;


//danglin PivotPoint MA _ MOMENTUM
double M1ppma1_1;
double M1ppma1;
double M1ppma3_1;
double M1ppma3;
double M5ppma1_1;
double M5ppma3_1;
double M15ppma1;
double M15ppma1_1;
double M15ppma3;
double M15ppma3_1;
double sl_momentum;
double tp_momentum;
double trail_momentum;
double M5Openbar1;
double M1Openbar1;


//for H1 Reversal
double sl_H1Rev;
double tp_H1Rev;
double trail_H1Rev;
double cH1stochmain;
double H1stochmain;
double M15Bar3Lo;
double M15Bar3Hi; 
double M5Bar3Lo;
double M5Bar3Hi;
double M5Closebar1;
double pM5Close;
double pM5High;
double pM5Low;
double M5pivot;
double M5ppma1;
double M5ppma3;

//for EUROBREAKOUT
int q;
int time;
int time1;
int lookback = 9;
double lowvalue;
double highvalue;
extern int EuroStart = 6; //+3
extern int passEuroStart = 13;
double EURO_range;
double sl_EURO;
double tp_EURO;
double trail_EURO;

//for LONDON MOMENTUM
int p;
bool Londoncase;
int timeM5;
int time1M5;
double M5Close1;
double startprice;
extern int LondonStart = 7 ;
extern int passLondonStart = 14;
extern int pipvalue = 70;
extern int pipvaluerange = 80;

//for CASHCOW
double pdayRange;
double pdayClose;
double pdayOpen;
double pdayHigh;
double pdayLow;
double cdayRange;
double cdayClose;
double cdayOpen;
double cdayHigh;
double cdayLow;
double value1;
double value2;
double D1_ClLo;
double D1_HiCl;
double sl_CC;
double tp_CC;
double trail_CC;


//for ASSASSIN
double  Assassin_Long ;
double  Assassin_Short ;
double pWkHigh , pWkLow ,  pWkClose, pWkOpen, pdayMid;
double WkHigh, WkLow, WkClose, WkOpen;
double W1_ClLo;
double W1_HiCl;
double tp_assassin;
double sl_assassin;
double trail_assassin;


//for Inside Bar
double ppdayHigh;
double ppdayLow;
double sl_IB;
double tp_IB;
double trail_IB;
double H1Bar3Hi;
double H1Bar3Lo;

//for DANGLIN SCALPER
double M15stochmain;
double M5stochmain;
double M15RSI2;
double M15RSI4;
double M5RSI2;
double M5RSI4;
double cM5RSI2;
double cM5RSI4;
double pH1Close;
double pH1High;
double pH1Low;
double pM15High;
double pM15Low;
double pH1mid;
double pM15mid;
double sl_scalp;
double tp_scalp;
double trail_scalp;
double cM5CCI;
double M5CCI;
double M1Closebar1;
double M1Close;
double M1Open;






//---------END CUSTOM INDICATORS

//OTHER GENERAL DECLARATIONS
extern string mySymbol = "" ;

extern color myColorHeading   =  Gray ; 
extern color myColorValues    =  Yellow ; 

string   labelNames;
string   shortName;

int      corner;
int      totalLabels;
int      window;    
int      xPoint ;
color ColorHeading  ; 
color ColorValues ; 
color ColorPrice ;

double point ;
double Bar3Hi;
double Bar3Lo;
double ask;
double bid;
double spread;
 
string ArrowN   = ""; // north
string ArrowNE  = "";  // northeast
string ArrowE   = "";  // east
string ArrowSE  = "";  // southeast
string ArrowS   = "";  // south

//-----------My ATR CALCULATIONS-------

         double M15_atr10;
         double M15_atr20;
         double M15_atrmax;
         double M15_atrmid;
         double M15_atravg;
         double M15_atrtrail;
         double H1_atr10;
         double H1_atr20;
         double H1_atrmax;
         double H1_atrmid;
         double H1_atravg;
         double H1_atrtrail;
         double H4_atr10;
         double H4_atr20;
         double H4_atrmax;
         double H4_atrmid;
         double H4_atrtrail;
         double day_atr10;
         double day_atr20;
         double day_atrmax;
         double day_atrmid;
         double day_atravg;
         double day_atrtrail;
         double wk_atr10;
         double wk_atr20;
         double wk_atrmax;
         double wk_atrmid;
         double wk_atrtrail;
         
//--MACD DECLARATIONS-----//

double macd_HH1;
double macd_H1;
double macd_HH4;
double macd_H4;
double macd_MM1;
double macd_M1;
double macd_MM5;
double macd_M5;
double macd_D1;
double macd_DD1;

//---END DECLARATIONS

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   corner     = 0;
   shortName  = MakeUniqueName("$D_Multi1 ","");
   labelNames = shortName;
      IndicatorShortName(shortName);
 
 if( mySymbol == "" ) { mySymbol = Symbol() ; }
 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   while (totalLabels>0) { ObjectDelete(StringConcatenate(labelNames,totalLabels)); totalLabels--;}
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
bool sFirst = true ;

window      = WindowFind(shortName);
   
if ( sFirst ) {
sFirst = false ;
ObjectsDeleteAll( window, 21);
ObjectsDeleteAll( window, 22);
ObjectsDeleteAll( window, 23);
DoHead() ;
}
//----

point =MarketInfo(mySymbol,MODE_POINT);  


ColorHeading      = myColorHeading ; 
ColorValues       = myColorValues ; 
ColorValuesMomentum  = myColorValues ; 
ColorValuesH1Rev  = myColorValues ; 
ColorValuesEURO  = myColorValues ; 
ColorValuesLONDON  = myColorValues ; 
ColorValuesCC  = myColorValues ; 
ColorValuesASSASSIN = myColorValues;
ColorValuesIB  = myColorValues ; 
ColorValuesscalp  = myColorValues ; 

   pAlertMomentum        = tAlertMomentum ;
   tAlertMomentum        = "WAIT" ;
   PriceMomentum         = 0 ;
   
 //CUSTOM VARIABLE DEFINITIONS
 //----------------------------
   //----H4 Reversal Strategy---
   M5Close     = iClose(mySymbol,PERIOD_M5,0);
   M5Open      = iOpen(mySymbol,PERIOD_M5,0); 
   M5Close1     = iClose(mySymbol,PERIOD_M5,1);
   M15Close     = iClose(mySymbol,PERIOD_M15,0);
   M15Open      = iOpen(mySymbol,PERIOD_M15,0); 
   M30High      = iHigh(mySymbol,PERIOD_M30,0);  
   M30Low      = iLow(mySymbol,PERIOD_M30,0);  
   M30Close      = iClose(mySymbol,PERIOD_M30,0);  
   M30Open      = iOpen(mySymbol,PERIOD_M30,0); 
   H1Open        = iOpen(mySymbol,PERIOD_H1,0);
   H1Close       = iClose(mySymbol,PERIOD_H1,0);
   H4Open        = iOpen(mySymbol,PERIOD_H4,0);
   H4Close       = iClose(mySymbol,PERIOD_H4,0);
   D1Open        = iOpen(mySymbol,PERIOD_D1,0);
   D1Close       = iClose(mySymbol,PERIOD_D1,0);
   D1High        = iHigh(mySymbol,PERIOD_D1,0);
   D1Low       = iLow(mySymbol,PERIOD_D1,0);
   H4stochmain   = iStochastic(mySymbol,PERIOD_H4,8,3,3,MODE_SMA,1,MODE_MAIN,1);
   cH4stochmain   = iStochastic(mySymbol,PERIOD_H4,8,3,3,MODE_SMA,1,MODE_MAIN,0);
   cD1RSI2           =   iRSI(mySymbol,PERIOD_D1,2,PRICE_CLOSE,0);
   cD1RSI4           =   iRSI(mySymbol,PERIOD_D1,4,PRICE_CLOSE,0);
   cH4RSI2           =   iRSI(mySymbol,PERIOD_H4,2,PRICE_CLOSE,0);
   cH4RSI4           =   iRSI(mySymbol,PERIOD_H4,4,PRICE_CLOSE,0);
   H4RSI2           =   iRSI(mySymbol,PERIOD_H4,2,PRICE_CLOSE,1);
   H4RSI4           =   iRSI(mySymbol,PERIOD_H4,4,PRICE_CLOSE,1);
   H1RSI2           =   iRSI(mySymbol,PERIOD_H1,2,PRICE_CLOSE,1);
   H1RSI4           =   iRSI(mySymbol,PERIOD_H1,4 ,PRICE_CLOSE,1);
   cH1RSI2           =   iRSI(mySymbol,PERIOD_H1,2,PRICE_CLOSE,0);
   cH1RSI4           =   iRSI(mySymbol,PERIOD_H1,4 ,PRICE_CLOSE,0);
   cM15RSI2           =   iRSI(mySymbol,PERIOD_M15,2,PRICE_CLOSE,0);
   cM15RSI4           =   iRSI(mySymbol,PERIOD_M15,4,PRICE_CLOSE,0);
   cM15CCI      =     iCCI(mySymbol,PERIOD_M15,5,PRICE_CLOSE,0);
   M15CCI      =     iCCI(mySymbol,PERIOD_M15,5,PRICE_CLOSE,1);
   H1CCI      =     iCCI(mySymbol,PERIOD_H1,5,PRICE_CLOSE,1);
   cH1CCI      =     iCCI(mySymbol,PERIOD_H1,5,PRICE_CLOSE,0);
   close         = iClose(mySymbol,PERIOD_H4,0);
   open          = iOpen(mySymbol,PERIOD_H4,0);   
   M30Bar3Hi    = iHigh(mySymbol,PERIOD_M30,3);
   M30Bar3Lo    = iLow(mySymbol,PERIOD_M30,3);
   
   //------For DANGLIN Pivot Point MA _ MOMENTUM
   M5Openbar1 = iOpen(mySymbol,PERIOD_M5,1);
   M1Openbar1     =  iOpen(mySymbol,PERIOD_M1,1);
   
   //----For H1 reversal
   
   cH1stochmain   = iStochastic(mySymbol,PERIOD_H1,8,3,3,MODE_SMA,1,MODE_MAIN,0);
   H1stochmain   = iStochastic(mySymbol,PERIOD_H1,8,3,3,MODE_SMA,1,MODE_MAIN,1);
   M15Bar3Hi    = iHigh(mySymbol,PERIOD_M15,3);
   M15Bar3Lo    = iLow(mySymbol,PERIOD_M15,3);
   M5Bar3Hi    = iHigh(mySymbol,PERIOD_M5,3);
   M5Bar3Lo    = iLow(mySymbol,PERIOD_M5,3);
   M5Closebar1 = iClose(mySymbol,PERIOD_M5,1);
   pM5Close   =  iClose(mySymbol,PERIOD_M5,1);
   pM5High    = iHigh(mySymbol,PERIOD_M5,1);
   pM5Low    = iLow(mySymbol,PERIOD_M5,1);
   M5pivot  = (pM5Close + pM5High + pM5Low)/3;
   
   
         
         
         
         //----------------------------------------------------------------------------------------
 // FOR EURO BREAKOUT
 time = iTime(mySymbol,PERIOD_H1,0);
 time1 = iTime(mySymbol,PERIOD_H1,1);
 
 //FOR LONDON MOMENTUM
 timeM5 = iTime(mySymbol,PERIOD_M5,0);
 time1M5 = iTime(mySymbol,PERIOD_M5,1);
 
  //---- For CashCow
   pdayHigh       = iHigh(mySymbol,PERIOD_D1,1);
   pdayLow        = iLow(mySymbol,PERIOD_D1,1);
   cdayHigh       = iHigh(mySymbol,PERIOD_D1,0);
   cdayLow        = iLow(mySymbol,PERIOD_D1,0);
   pdayRange      = pdayHigh - pdayLow;
   cdayRange      = cdayHigh - cdayLow;
   pdayClose      = iClose(mySymbol,PERIOD_D1,1);
   pdayOpen       = iOpen(mySymbol,PERIOD_D1,1);
   cdayClose      = iClose(mySymbol,PERIOD_D1,0);
   cdayOpen       = iOpen(mySymbol,PERIOD_D1,0);
   value1         = pdayHigh + 30*point;
   value2         = pdayLow - 30*point;
   D1_ClLo        = (D1Close - D1Low)/point;
   D1_HiCl        = (D1High - D1Close)/point;
   H1Bar3Hi    = iHigh(mySymbol,PERIOD_H1,3);
   H1Bar3Lo    = iLow(mySymbol,PERIOD_H1,3);
   
//--- For ASSASSIN
   pWkHigh        = iHigh(mySymbol,PERIOD_W1,1);
   pWkLow         = iLow(mySymbol,PERIOD_W1,1);
   pWkClose       = iClose(mySymbol,PERIOD_W1,1); 
   pWkOpen       = iOpen(mySymbol,PERIOD_W1,1); 
   WkHigh        = iHigh(mySymbol,PERIOD_W1,0);
   WkLow         = iLow(mySymbol,PERIOD_W1,0);
   WkClose       = iClose(mySymbol,PERIOD_W1,0); 
   WkOpen       = iOpen(mySymbol,PERIOD_W1,0);
   Assassin_Long  = pWkClose+(pWkHigh-pWkLow)/3;
   Assassin_Short = pWkClose-(pWkHigh-pWkLow)/3;
   pdayMid        = (pdayHigh - pdayLow)/2;
   W1_ClLo        = (WkClose - WkLow)/point;
   W1_HiCl        = (WkHigh - WkClose)/point;
   

//---FOR INSIDE Bar
ppdayHigh       = iHigh(mySymbol,PERIOD_D1,2);
ppdayLow        = iLow(mySymbol,PERIOD_D1,2);


//FOR DANGLIN SCALPER
   M15stochmain     = iStochastic(mySymbol,PERIOD_M15,8,3,3,MODE_SMA,1,MODE_MAIN,1);
   M5stochmain     = iStochastic(mySymbol,PERIOD_M5,8,3,3,MODE_SMA,1,MODE_MAIN,1);
   M15RSI2          =   iRSI(mySymbol,PERIOD_M15,2,PRICE_CLOSE,1);
   M15RSI4          =   iRSI(mySymbol,PERIOD_M15,4,PRICE_CLOSE,1);
   M5RSI2           =   iRSI(mySymbol,PERIOD_M5,2,PRICE_CLOSE,1);
   M5RSI4           =   iRSI(mySymbol,PERIOD_M5,4,PRICE_CLOSE,1);
   cM5RSI2          =   iRSI(mySymbol,PERIOD_M5,2,PRICE_CLOSE,0);
   cM5RSI4          =   iRSI(mySymbol,PERIOD_M5,4,PRICE_CLOSE,0);
   pH1Close          =  iClose(mySymbol,PERIOD_H1,1);
   pH1High          =  iHigh(mySymbol,PERIOD_H1,1);
   pH1Low           =   iLow(mySymbol,PERIOD_H1,1);
   pM15High          =  iHigh(mySymbol,PERIOD_M15,1);
   pM15Low           =  iLow(mySymbol,PERIOD_M15,1);
   pH1mid           = (pH1High + pH1Low)*0.5;
   pM15mid           = (pM15High + pM15Low)*0.5;
   
   Bar3Hi           = iHigh(mySymbol,PERIOD_M15,3);
   Bar3Lo           = iLow(mySymbol,PERIOD_M15,3);
   bid              = MarketInfo(mySymbol,MODE_BID);
   ask              = MarketInfo(mySymbol,MODE_ASK);
   spread           = ask - bid;
   cM5CCI           =     iCCI(mySymbol,PERIOD_M5,15,PRICE_CLOSE,0);
   M5CCI            =     iCCI(mySymbol,PERIOD_M5,15,PRICE_CLOSE,1);
   M1Closebar1      =  iClose(mySymbol,PERIOD_M1,1);
   M1Close          =  iClose(mySymbol,PERIOD_M1,0);
   M1Open         =  iOpen(mySymbol,PERIOD_M1,0);
   
   
   
   //---PIVOT POINT MOVING AVERAGE INDICATOR--//
    M1ppma1            = iMA(mySymbol,PERIOD_M1,1,0,MODE_SMA,PRICE_TYPICAL,0);
    M1ppma1_1            = iMA(mySymbol,PERIOD_M1,1,0,MODE_SMA,PRICE_TYPICAL,1);
    M1ppma3            = iMA(mySymbol,PERIOD_M1,3,0,MODE_SMA,PRICE_TYPICAL,0);
    M1ppma3_1            = iMA(mySymbol,PERIOD_M1,3,0,MODE_SMA,PRICE_TYPICAL,1);
    M5ppma1            = iMA(mySymbol,PERIOD_M5,1,0,MODE_SMA,PRICE_TYPICAL,0);
    M5ppma1_1           = iMA(mySymbol,PERIOD_M5,1,0,MODE_SMA,PRICE_TYPICAL,1);
    M5ppma3            = iMA(mySymbol,PERIOD_M5,3,0,MODE_SMA,PRICE_TYPICAL,0);
    M5ppma3_1            = iMA(mySymbol,PERIOD_M5,3,0,MODE_SMA,PRICE_TYPICAL,1);
    M15ppma1            = iMA(mySymbol,PERIOD_M15,1,0,MODE_SMA,PRICE_TYPICAL,0);
    M15ppma1_1           = iMA(mySymbol,PERIOD_M15,1,0,MODE_SMA,PRICE_TYPICAL,1);
    M15ppma3            = iMA(mySymbol,PERIOD_M15,3,0,MODE_SMA,PRICE_TYPICAL,0);
    M15ppma3_1            = iMA(mySymbol,PERIOD_M15,3,0,MODE_SMA,PRICE_TYPICAL,1);
   

//-------FOR ATR CALCULATION----------//
 day_atr10 = iATR(mySymbol,PERIOD_D1,10,0);
 day_atr20 = iATR(mySymbol,PERIOD_D1,20,0);
 day_atrmax = MathMax(day_atr10,day_atr20);
 day_atrmid = (day_atrmax)*0.5/point;
 day_atravg = (day_atr10 + day_atr20)*0.5/point;
 day_atrtrail = (day_atrmax)*0.7/point;

 wk_atr10 = iATR(mySymbol,PERIOD_W1,10,0);
 wk_atr20 = iATR(mySymbol,PERIOD_W1,20,0);
 wk_atrmax = MathMax(wk_atr10,wk_atr20);
 wk_atrmid = (wk_atrmax)*0.5/point;
 wk_atrtrail = (wk_atrmax)*0.7/point;
 
 H4_atr10 = iATR(mySymbol,PERIOD_H4,10,0);
 H4_atr20 = iATR(mySymbol,PERIOD_H4,20,0);
 H4_atrmax = MathMax(H4_atr10,H4_atr20);
 H4_atrmid = (H4_atrmax)*0.5/point;
 H4_atrtrail = (H4_atrmax)*0.7/point;
 
 H1_atr10 = iATR(mySymbol,PERIOD_H1,10,0);
 H1_atr20 = iATR(mySymbol,PERIOD_H1,20,0);
 H1_atrmax = MathMax(H1_atr10,H1_atr20);
 H1_atrmid = (H1_atrmax)*0.5/point;
 H1_atravg = (H1_atr10 + H1_atr20)*0.5/point;
 H1_atrtrail = (H1_atrmax)*0.7/point;
 
 M15_atr10 = iATR(mySymbol,PERIOD_M15,10,0);
 M15_atr20 = iATR(mySymbol,PERIOD_M15,20,0);
 M15_atrmax = MathMax(M15_atr10,M15_atr20);
 M15_atrmid = (M15_atrmax)*0.5/point;
 M15_atravg = (M15_atr10 + M15_atr20)*0.5/point;
 M15_atrtrail = (M15_atrmax)*0.7/point;
 
 //----MACD DEFINITIONS----//
   macd_H1=iMACD(NULL,PERIOD_H1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
   macd_HH1=iMACD(NULL,PERIOD_H1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
   macd_H4=iMACD(NULL,PERIOD_H4,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
   macd_HH4=iMACD(NULL,PERIOD_H4,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
   macd_M1=iMACD(NULL,PERIOD_M1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
   macd_MM1=iMACD(NULL,PERIOD_M1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
   macd_M5=iMACD(NULL,PERIOD_M5,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
   macd_MM5=iMACD(NULL,PERIOD_M5,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
   macd_D1=iMACD(NULL,PERIOD_D1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
   macd_DD1=iMACD(NULL,PERIOD_D1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
 
//----------
int hSize = 9 ;

if ( point == 0.01 )  {xPoint = 2 ; } else { xPoint = 4 ;  } 
   
//------------- 

if(use.momentum)     { DoMomentum(); } 
if(use.H1Rev)     { DoH1Rev(); } 
if(use.CashCow)   { DoCashCow(); } 
if(use.ASSASSIN)   { DoASSASSIN(); } 
if(use.LONDON)   { DoLONDON(); } 
if(use.EURO)   { DoEURO(); } 
if(use.IB)   { DoIB(); } 
if(use.scalp)   { Doscalp(); } 



//-------------    

if(close > open) { ColorPrice = Lime ; } else {
if(close < open) { ColorPrice = Red ; } else {ColorPrice = Yellow ; } }

setObject(next(),mySymbol,10+price.x.offset, 5+price.y.offset,ColorHeading ,"Arial bold",hSize);

setObject(next(), DoubleToStr(close,xPoint),75+price.x.offset, 5+price.y.offset, ColorPrice ,"Arial bold",hSize);               


if(use.momentum)     { 
setObject(next(),tAlertMomentum +" " + DoubleToStr(pAlertMomentum,xPoint),200+price.x.offset, 5+price.y.offset, ColorValuesMomentum ,"Arial bold",hSize);
setObject(next(),"SL  " +" " + DoubleToStr(sl_momentum,xPoint),200+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);
setObject(next(),"TP  " +" " + DoubleToStr(tp_momentum,xPoint),200+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize);
//setObject(next(),ArrowMomentum ,275+price.x.offset, 5+price.y.offset, ShTriggerMomentum ,"Wingdings",hSize);            
}
if(use.H1Rev)     { 
setObject(next(),tAlertH1Rev +" " + DoubleToStr(PriceH1Rev,xPoint),300+price.x.offset, 5+price.y.offset, ColorValuesH1Rev ,"Arial bold",hSize);
setObject(next(),"SL  " +" " + DoubleToStr(sl_H1Rev,xPoint),300+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);
setObject(next(),"TP  " +" " + DoubleToStr(tp_H1Rev,xPoint),300+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize);



//setObject(next(),ArrowH1Rev ,375+price.x.offset, 5+price.y.offset, colorArrowH1Rev ,"Wingdings",hSize);            
}
if(use.scalp)     { 
setObject(next(),tAlertscalp +" " + DoubleToStr(Pricescalp,xPoint),400+price.x.offset, 5+price.y.offset, ColorValuesscalp ,"Arial bold",hSize);
setObject(next(),"SL  " +" " + DoubleToStr(sl_scalp,xPoint),400+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);
setObject(next(),"TP  " +" " + DoubleToStr(tp_scalp,xPoint),400+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize);
//setObject(next(),Arrowscalp ,475+price.x.offset, 5+price.y.offset, colorArrowscalp ,"Wingdings",hSize);            
}
if(use.EURO)   { 
setObject(next(),tAlertEURO    +" " + DoubleToStr(PriceEURO,xPoint),500+price.x.offset, 5+price.y.offset, ColorValuesEURO ,"Arial bold",hSize); 
setObject(next(),"SL  "    +" " + DoubleToStr(sl_EURO,xPoint),500+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);  
setObject(next(),"TP  "    +" " + DoubleToStr(tp_EURO,xPoint),500+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize); 
setObject(next(),"ATRtrail  "    +" " + DoubleToStr(trail_EURO,xPoint),500+price.x.offset, 50+price.y.offset, Blue ,"Arial bold",hSize); 
//setObject(next(),ArrowEURO ,575+price.x.offset, 5+price.y.offset, colorArrowEURO ,"Wingdings",hSize);             
}
if(use.LONDON )   { 
setObject(next(),tAlertLONDON   +" " + DoubleToStr(PriceLONDON,xPoint),600+price.x.offset, 5+price.y.offset, ColorValuesLONDON ,"Arial bold",hSize);               
}
if(use.CashCow )   { 
setObject(next(),tAlertCC   +" " + DoubleToStr(PriceCC,xPoint),700+price.x.offset, 5+price.y.offset, ColorValuesCC ,"Arial bold",hSize); 
setObject(next(),"SL  "   +" " + DoubleToStr(sl_CC,xPoint),700+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);   
setObject(next(),"TP  "   +" " + DoubleToStr(tp_CC,xPoint),700+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize);   
setObject(next(),"ATRtrail  "   +" " + DoubleToStr(trail_CC,xPoint),700+price.x.offset, 50+price.y.offset, Blue ,"Arial bold",hSize);  
}
if(use.ASSASSIN )   { 
setObject(next(),tAlertASSASSIN   +" " + DoubleToStr(PriceASSASSIN,xPoint),800+price.x.offset, 5+price.y.offset, ColorValuesASSASSIN ,"Arial bold",hSize);               
setObject(next(),"SL  "   +" " + DoubleToStr(sl_assassin,xPoint),800+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);
setObject(next(),"TP  "   +" " + DoubleToStr(tp_assassin,xPoint),800+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize);

}
if(use.IB)     { 
setObject(next(),tAlertIB +" " + DoubleToStr(PriceIB,xPoint),900+price.x.offset, 5+price.y.offset, ColorValuesIB ,"Arial bold",hSize);
setObject(next(),"SL  " +" " + DoubleToStr(sl_IB,xPoint),900+price.x.offset, 20+price.y.offset, Blue ,"Arial bold",hSize);
setObject(next(),"TP  " +" " + DoubleToStr(tp_IB,xPoint),900+price.x.offset, 35+price.y.offset, Blue ,"Arial bold",hSize);
setObject(next(),"ATRtrail  " +" " + DoubleToStr(trail_IB,xPoint),900+price.x.offset, 50+price.y.offset, Blue ,"Arial bold",hSize);
//setObject(next(),ArrowIB ,975+price.x.offset, 5+price.y.offset, colorArrowIB ,"Wingdings",hSize);            
}


//----
   return(0);
  }
//+------------------------------------------------------------------+

string next() { totalLabels++; return(totalLabels); }  

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//+------------------------------------------------------------------+
void setObject(string name,string text,int x,int y,color theColor, string font = "Arial",int size=10,int angle=0)
{
   string labelName = StringConcatenate(labelNames,name);

      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,window,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,corner);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}

//+------------------------------------------------------------------+
void DoHead ()
{
int hSize = 9 ;

setObject(next(),"Price",75+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
//setObject(next(),"H1 Price",125+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               


if(use.momentum)     { 
setObject(next(),"Momentum",200+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
   }
 if(use.H1Rev)     { 
setObject(next(),"H1Rev",300+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
   }
 if(use.scalp)     { 
setObject(next(),"M15SCALP",400+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
   }
if(use.EURO)   {
setObject(next(),"EURO",500+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
}
if(use.LONDON )   {   
setObject(next(),"LONDON",600+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
} 
if(use.CashCow )   {   
setObject(next(),"CashCow",700+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
}
if(use.ASSASSIN )   {   
setObject(next(),"ASSASSIN",800+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
}
if(use.IB)     { 
setObject(next(),"I_BAR",900+price.x.offset, -10+price.y.offset, ColorHeading ,"Arial bold",hSize);               
   }


}

//+------------------------------------------------------------------+
// DANGLIN PIVOT POINT MA _MOMENTUM
//+------------------------------------------------------------------+
void  DoMomentum()
{ 
   pAlertMomentum        = tAlertMomentum ;
   tAlertMomentum        = "WAIT";
  sl_momentum         = 0 ;
  tp_momentum         = 0;
   

   if((M30High - M30Low)/point > myRange
   && macd_H4 > macd_HH4  //--GENERAL TREND IS UP --//
   && macd_H1 > macd_HH1 //------------------------//
   && H1Close > H1Open
   && M5stochmain <= 30
   && M5Close > M5Open
   && M5Close >= M5pivot
   && M1ppma1_1 > M1ppma3_1
   && M1Closebar1 > M1ppma1_1)
   {

   tAlertMomentum       = "BUY";
   sl_momentum         = (M5Close -(M5Bar3Lo - 3*point))/point;
   tp_momentum         =  H1_atravg;
   if (LgTriggerMomentum == false)   { 
      PriceMomentum = close ;
      if (pAlertMomentum == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol ,"HI_PPMA MOMENTUM BUY "+ DoubleToStr(PriceMomentum,xPoint)); }
         Print(mySymbol ,"H1 PPMA_Momentum BUY");
      }
    }
   ColorValuesMomentum  = Lime ; 
   LgTriggerMomentum =  true ; 
   }
   
  if((M30High - M30Low)/point > myRange
   && macd_H4 < macd_HH4  //--GENERAL TREND IS DOWN --//
   && macd_H1 < macd_HH1 //------------------------//
   && H1Close < H1Open
   && M5stochmain >= 70
   && M5Close < M5Open
   && M5Close <= M5pivot
   && M1ppma1_1 < M1ppma3_1
   && M1Closebar1 < M1ppma1_1)
   {

   tAlertMomentum       = "SHORT" ;
   tp_momentum = ((M5Bar3Hi + 3*point + spread)-M5Close)/point;
   tp_momentum         = H1_atravg;
   if (ShTriggerMomentum == false)    {
       PriceMomentum = close ; 
       if (pAlertMomentum == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," H1 PPMA_MOMENTUM SHORT "+ DoubleToStr(PriceMomentum,xPoint)); }
          Print(mySymbol," H1 PPMA_MOEMNTUM SHORT");       
       }
    }

   colorArrowMomentum  = Red ; 
   ShTriggerMomentum =  true ;    
   }   

   if (tAlertMomentum == "WAIT") { ArrowMomentum = false ; ShTriggerMomentum = false ; }


}

 //+------------------------------------------------------------------+
// EURO BREAKOUT
//+------------------------------------------------------------------+
void DoEURO()
{

   pAlertEURO        = tAlertEURO ;
   tAlertEURO        = "WAIT";
   
         //EURO_range = 0;
         q = 0;
		   if (TimeHour(time) == EuroStart)
			lowvalue =   Low[iLowest(mySymbol,PERIOD_H1,MODE_LOW,lookback,0)];
         highvalue = High[iHighest(mySymbol,PERIOD_H1,MODE_HIGH,lookback,0)];
         EURO_range = (highvalue - lowvalue)/point;
        
			if (TimeHour(time) >= EuroStart && TimeHour(time) < passEuroStart)
				q = 1;
			
			switch (q)
			{
				case 0:
					break;
				case 1:
					if (TimeHour(time) >= EuroStart)
					{
					if(H1Close >= highvalue + 5*point 
						&& H1Close < highvalue + 10*point 
						&& H1Close > H1Open
						&& M5Close > M5Open
						&& M15Close > M15Open
						&& EURO_range <= day_atrmid)
         {
         

   tAlertEURO       = "BUY";
   sl_EURO = (M5Close - lowvalue - point)/point;
   tp_EURO         = H1_atravg;
   trail_EURO     = H1_atrtrail;
   if (LgTriggerEURO == false)   { 
      PriceEURO = close ;
      if (pAlertEURO == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol," EURO BREAKOUT BUY "+ DoubleToStr(PriceEURO,xPoint)); }
         Print(mySymbol," EURO BREAKOUT BUY");
      }
    }

   ColorValuesEURO  = Lime ; 
   LgTriggerEURO =  true ; 
   }
   if(H1Close <= lowvalue - 5*point
						&& H1Close > lowvalue - 10*point 
						&& H1Close < H1Open
						&& M5Close < M5Open
						&& M15Close < M15Open
						&& EURO_range <= day_atrmid)
						
   {

   tAlertEURO       = "SHORT" ;
   sl_EURO = (highvalue - M5Close + point)/point;
   tp_EURO         = H1_atravg;
   trail_EURO     = H1_atrtrail;
   if (ShTriggerEURO == false)    {
       PriceEURO = close ; 
       if (pAlertEURO == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," EURO BREAKOUT SHORT "+ DoubleToStr(PriceEURO,xPoint)); }
          Print(mySymbol,"EURO BREAKOUT SHORT");       
       }
    }

   ColorValuesEURO  = Red ; 
   ShTriggerEURO =  true ;    
   }   
		}
if (pAlertEURO == "WAIT") {  LgTriggerEURO = false ; ShTriggerEURO = false ; }
					break;
		 }
	
	}	
	
//+------------------------------------------------------------------+
// LONDON MOMENTUM
//+------------------------------------------------------------------+
void DoLONDON()
{

   pAlertLONDON        = tAlertLONDON ;
   tAlertLONDON        = "WAIT";
   Londoncase = false; 
      p = 0;
			if (TimeMinute(timeM5) == LondonStart) //start of 4 a.m. bar. 
			{startprice = M5Close1 ;} //Use close[1] to reference the 3 a.m. time
			if (TimeMinute(timeM5) > LondonStart && TimeMinute(timeM5) < passLondonStart)
			{	p = 1; Londoncase = true;}
			
			switch (p)
			{
				case 0:
					break;
				case 1:
					{
					if(Londoncase == true
					&& M5Close > startprice + pipvalue*point 
					&& M5Close < startprice + pipvaluerange*point 
					&& M5Close > M5Open)
					{

   tAlertLONDON       = "BUY";
   if (LgTriggerLONDON == false)   { 
      PriceLONDON = M5Close ;
      if (pAlertLONDON == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol," LONDON BUY "+ DoubleToStr(PriceLONDON,xPoint)); }
         Print(mySymbol," BUY");
      }
    }

   ColorValuesLONDON  = Lime ; 
   LgTriggerLONDON =  true ; 
   }
		if(Londoncase == true
		&& M5Close < startprice - pipvalue*point 
		&& M5Close > startprice - pipvaluerange*point 
		&& M5Close < M5Open)
		{

   tAlertLONDON       = "SHORT" ;
   if (ShTriggerLONDON == false)    {
       PriceLONDON = M5Close ; 
       if (pAlertLONDON == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," LONDON SHORT "+ DoubleToStr(PriceLONDON,xPoint)); }
          Print(mySymbol,"SHORT");       
       }
    }

   ColorValuesLONDON  = Red ; 
   ShTriggerLONDON =  true ;    
   }   
					}
	if (pAlertLONDON == "WAIT") {  LgTriggerLONDON = false ; ShTriggerLONDON = false ; }
					break;
			}
}

//+------------------------------------------------------------------+
// CashCow
//+------------------------------------------------------------------+
void  DoCashCow()
{ 
   pAlertCC        = tAlertCC ;
   tAlertCC        = "WAIT";
   PriceCC         = 0 ;
   

   if(pdayRange >= 140*point //yesterday explosive price movement
   && pdayClose > pdayOpen  //yesterday was green
   && cdayRange >= 70*point // today's price movement still has momentum
   && cdayClose > cdayOpen // Up on the Day
   && cdayClose >= value1)  // Strong Trend up that may take one more day to finish.  SL 60pips. Limit100pips. Trade on GBPJPY, GBPUSD and EURUSD 
   
   {

   tAlertCC       = "BUY";
   sl_CC = (H1Close - H1Bar3Lo - 3*point)/point;
   tp_CC         = day_atravg;
   trail_CC     = day_atrtrail;
   if (LgTriggerCC == false)   { 
      PriceCC = close ;
      if (pAlertCC == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol," CashCow BUY "+ DoubleToStr(PriceCC,xPoint)); }
         Print(mySymbol,"BUY");
      }
    }
//   PriceCC = close ;
   ColorValuesCC  = Lime ; 
   LgTriggerCC =  true ; 
   }
   
  if(pdayRange >= 140*point 
   && pdayClose < pdayOpen  
   && cdayRange <= 70*point 
   && cdayClose < cdayOpen 
   && cdayClose <= value2)  
   {

   tAlertCC       = "SHORT" ;
   sl_CC = ((H1Bar3Hi + 3*point + spread) - H1Close)/point;
   tp_CC         = day_atravg;
   trail_CC     = day_atrtrail;
   if (ShTriggerCC == false)    {
       PriceCC = close ; 
       if (pAlertCC == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," CashCow SHORT "+ DoubleToStr(PriceCC,xPoint)); }
          Print(mySymbol,"SHORT");       
       }
    }
//   PriceCC = close ;
   ColorValuesCC  = Red ; 
   ShTriggerCC =  true ;    
   }   

   if (tAlertCC == "WAIT") { LgTriggerCC = false ; ShTriggerCC = false ; }
   }
 //+------------------------------------------------------------------+
//   FOREX ASSASSIN
//+------------------------------------------------------------------+


void DoASSASSIN()
{

   pAlertASSASSIN        = tAlertASSASSIN ;
   tAlertASSASSIN        = "WAIT";
   
   if(cdayClose == Assassin_Long 
   && D1Close > D1Open
   && WkClose > WkOpen
   //&& pWkClose > pWkOpen
   && WkLow > pWkLow)
   {

   tAlertASSASSIN       = "BUY";
   sl_assassin          = ((pWkHigh - pWkLow)/3)/point; 
   tp_assassin         = wk_atrmid;
   trail_assassin     = wk_atrtrail;
   if (LgTriggerASSASSIN == false)   { 
      PriceASSASSIN = close ;
      if (pAlertASSASSIN == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol," ASSASSIN BUY "+ DoubleToStr(PriceASSASSIN,xPoint)); }
         Print(mySymbol,"BUY");
      }
    }

   ColorValuesASSASSIN  = Lime ; 
   LgTriggerASSASSIN =  true ; 
   }

   if(cdayClose == Assassin_Short 
   && D1Close < D1Open
   && WkClose < WkOpen
   //&& pWkClose < pWkOpen
   && WkHigh < pWkHigh)
   
   {

   tAlertASSASSIN       = "SHORT" ;
   tp_assassin         = wk_atrmid;
   trail_assassin     = wk_atrtrail;
   if (ShTriggerASSASSIN == false)    {
       PriceASSASSIN = close ; 
       if (pAlertASSASSIN == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," ASSASSIN SHORT "+ DoubleToStr(PriceASSASSIN,xPoint)); }
          Print(mySymbol,"SHORT");       
       }
    }

   ColorValuesASSASSIN  = Red ; 
   ShTriggerASSASSIN =  true ;    
   }   

   if (pAlertASSASSIN == "WAIT") {  LgTriggerASSASSIN = false ; ShTriggerASSASSIN = false ; }
}


////+------------------------------------------------------------------+
//  INSIDE BAR
//+------------------------------------------------------------------+


void  DoIB()
{ 
   pAlertIB        = tAlertIB ;
   tAlertIB        = "WAIT";
   

   if((M30High - M30Low)/point > myRange
   && pdayLow > ppdayLow
   && pdayHigh < ppdayHigh
   && D1Close > (pdayHigh + 5*point)
   && macd_H4 > macd_HH4  //--GENERAL TREND IS UP --//
   && macd_H1 > macd_HH1 //------------------------//  
   && macd_M5 > macd_MM5
   && macd_M1 > macd_MM1)
   
   {

   tAlertIB       = "BUY";
   sl_IB = (D1Close - pdayLow - 5*point)/point;
   tp_IB         = day_atravg;  //or 20 pips
   //trail_IB     = day_atrtrail;
   if (LgTriggerIB == false)   { 
      PriceIB = close ;
      if (pAlertIB == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol,"INSIDE BAR BUY "+ DoubleToStr(PriceIB,xPoint)); }
         Print(mySymbol,"Inside Bar BUY");
      }
    }
   ColorValuesIB  = Lime ; 
   LgTriggerIB =  true ; 
   }
   
  if((M30High - M30Low)/point > myRange
   && D1Close < D1Open
   && pdayLow > ppdayLow
   && pdayHigh < ppdayHigh
   && D1Close < (pdayLow - 5*point)
   && macd_H4 < macd_HH4  //--GENERAL TREND IS UP --//
   && macd_H1 < macd_HH1 //------------------------// 
   && macd_M5 < macd_MM5
   && macd_M1 < macd_MM1)
   {

   tAlertIB       = "SHORT" ;
   sl_IB = ((pdayHigh + 5*point + spread) - D1Close)/point;
   tp_IB         = day_atravg;
   //trail_IB     = day_atrtrail;
   if (ShTriggerIB == false)    {
       PriceIB = close ; 
       if (pAlertIB == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," Inside Bar SHORT "+ DoubleToStr(PriceIB,xPoint)); }
          Print(mySymbol,"  Inside Bar SHORT");       
       }
    }

   ColorValuesIB  = Red ; 
   ShTriggerIB =  true ;    
   }   

   if (tAlertIB == "WAIT") { LgTriggerIB = false ; ShTriggerIB = false ; }


}

////+------------------------------------------------------------------+
//  DANGLIN M15 Reversal SCALPER
//+------------------------------------------------------------------+
void  Doscalp()
{ 
   pAlertscalp        = tAlertscalp ;
   tAlertscalp        = "WAIT";

   

   if((M30High - M30Low)/point > myRange
   && macd_H4 > macd_HH4  //--GENERAL TREND IS UP --//
   && macd_H1 > macd_HH1 //------------------------//
   && M15CCI <= -100
   && cM15CCI >= -100
   && M15stochmain <= 30
   && M15RSI2 <= 30
   && M15Close > M15Open
   && M5Close >= M5pivot
   && M5Close > M5Open
   && M1ppma1_1 > M1ppma3_1
   && M1Closebar1 > M1ppma1_1
   )   
   {

   tAlertscalp       = "BUY";
   sl_scalp =   (M5Close - M5Bar3Lo - 3*point)/point;
   tp_scalp         = M15_atravg;
   trail_scalp     = M15_atrtrail;
   if (LgTriggerscalp == false)   { 
      Pricescalp = close ;
      if (pAlertscalp == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol,"  M15 SCALPER BUY "+ DoubleToStr(Pricescalp,xPoint)); }
         Print(mySymbol,"  M15 SCALPER BUY");
      }
    }
   ColorValuesscalp  = Lime ; 
   LgTriggerscalp =  true ; 
   }
   
  if((M30High - M30Low)/point > myRange
   && macd_H4 < macd_HH4  //--GENERAL TREND IS DOWN --//
   && macd_H1 < macd_HH1 //------------------------//
   && M15CCI >= 100
   && cM15CCI <= 100
   && M15stochmain >= 70
   && M15RSI2 >= 70
   && M15Close < M15Open
   && M5Close <= M5pivot
   && M5Close < M5Open
   && M1ppma1_1 < M1ppma3_1
   && M1Closebar1 < M1ppma1_1)     
   {

   tAlertscalp       = "SHORT" ;
   sl_scalp = ((M5Bar3Hi + 3*point + spread)-M5Close)/point;
   tp_scalp         = M15_atravg;
   trail_scalp     = M15_atrtrail;
   if (ShTriggerscalp == false)    {
       Pricescalp = close ; 
       if (pAlertscalp == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol,"  M15 SCALPER SHORT "+ DoubleToStr(Pricescalp,xPoint)); }
          Print(mySymbol,"  M15 SCALPER SHORT");       
       }
    }

   ColorValuesscalp  = Red ; 
   ShTriggerscalp =  true ;    
   }   

   if (tAlertscalp == "WAIT") { LgTriggerscalp = false ; ShTriggerscalp = false ; }


}
//+------------------------------------------------------------------+
// H1 Reversal Scalper
//+------------------------------------------------------------------+
void  DoH1Rev()
{ 
   pAlertH1Rev        = tAlertH1Rev ;
   tAlertH1Rev        = "WAIT";
//   PriceH1Rev         = 0 ;
   
   //M5pivot = NormalizeDouble(M5pivot,Digits) ;

   if((M30High - M30Low)/point > myRange
   //&& macd_M1 > macd_MM1  //-----MACD SIGNAL UP ----//
   //&& macd_M5 > macd_MM5 //------------------------//
   && macd_D1 > macd_DD1
   && H1CCI <= -100
   && cH1CCI >= -100
   && H1stochmain <= 30
   && H1RSI2 <= 30
   && H1Close > H1Open
   && M5Close >= M5pivot
   && M5Close > M5Open
   && M1ppma1_1 > M1ppma3_1
   && M1Closebar1 > M1ppma1_1)   
   {

   tAlertH1Rev       = "BUY";
   sl_H1Rev         = (M5Close -(M5Bar3Lo - 3*point))/point;
   tp_H1Rev         = H1_atravg;
   //trail_H1Rev     = H1_atrtrail;
   if (LgTriggerH1Rev == false)   { 
      PriceH1Rev = close ;
      if (pAlertH1Rev == "WAIT") { 
         if ( my.alert.sound ) {Alert(mySymbol," H1 Rev BUY "+ DoubleToStr(PriceH1Rev,xPoint)); }
         Print(mySymbol," H1 Rev BUY");
      }
    }
   ColorValuesH1Rev  = Lime ; 
   LgTriggerH1Rev =  true ; 
   }
   
  if((M30High - M30Low)/point > myRange
   //&& macd_M1 < macd_MM1  //---MACD SIGNAL DOWN ----//
   //&& macd_M5 < macd_MM5 //------------------------//
   && macd_D1 < macd_DD1
   && H1CCI >= 100
   && cH1CCI <= 100
   && H1stochmain >= 70
   && H1RSI2 >= 70
   && H1Close < H1Open
   && M5Close <= M5pivot
   && M5Close < M5Open
   && M1ppma1_1 < M1ppma3_1
   && M1Closebar1 < M1ppma1_1)   
   {

   tAlertH1Rev       = "SHORT" ;
   sl_H1Rev = ((M5Bar3Hi + 3*point + spread)-M5Close)/point;
   tp_H1Rev         = H1_atravg;
   //trail_H1Rev     = H1_atrtrail;
   if (ShTriggerH1Rev == false)    {
       PriceH1Rev = close ; 
       if (pAlertH1Rev == "WAIT") { 
          if ( my.alert.sound ) {Alert(mySymbol," H1 Rev SHORT "+ DoubleToStr(PriceH1Rev,xPoint)); }
          Print(mySymbol," H1 Rev SHORT");       
       }
    }

   ColorValuesH1Rev  = Red ; 
   ShTriggerH1Rev =  true ;    
   }   

   if (tAlertH1Rev == "WAIT") { LgTriggerH1Rev = false ; ShTriggerH1Rev = false ; }


}