//+------------------------------------------------------------------+ 
//|   tro_midpoint_mtf                                               | 
//|                                                                  | 
//|   Copyright  2008, AVERY T. HORTON, JR. AKA TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
 

#property indicator_chart_window


extern int myChartY = 250 ;

double Hi, Li, C;

double prev_high, prev_low, prev_close, D, p, value ;
int h  ;
string lbl[15], lbl2[15];
int n, j ;

color pColor = Blue ;

string symbol, tChartPeriod, ShortName ;  
int    digits, period, win ; 
double point,  close  ;  


//+------------------------------------------------------------------+

int init()
  {
   period       = Period() ;
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    = "pmp"+symbol+period ;
   win          = 0 ;
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
//----
ObjectsDeleteAll();
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{
  

n         = 10;
close     = Close[0] ; 

j       = 0 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Prev Mid";
DoShow(j, SteelBlue);

DoWork(symbol , 1 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "M1  " + DoubleToStr(p,digits);
DoShow(j, pColor);
 
DoWork(symbol , 5 ) ;
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "M5  " + DoubleToStr(p,digits);
DoShow(j, pColor);

   
DoWork(symbol , 15 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "M15 " + DoubleToStr(p,digits);
DoShow(j, pColor); 
 
DoWork(symbol , 30 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "M30 " + DoubleToStr(p,digits);
DoShow(j, pColor);  
 
DoWork(symbol , 60 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "H1  " + DoubleToStr(p,digits);
DoShow(j, pColor);  
 
DoWork(symbol , 240 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "H4  " + DoubleToStr(p,digits);
DoShow(j, pColor);  
 
DoWork(symbol , 1440 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "D1  " + DoubleToStr(p,digits);
DoShow(j, pColor);  
 
DoWork(symbol , 10080 ) ;  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "W1  " + DoubleToStr(p,digits);
DoShow(j, pColor);  
 
DoWork(symbol , PERIOD_MN1 ) ;
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "MN  " + DoubleToStr(p,digits);
DoShow(j, pColor);  
 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "TheRumpledOne";
DoShow(j, DimGray);  
 
/*
for (int u=0;u<ArraySize(lbl);u++)
{
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u],OBJPROP_XDISTANCE,610);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n);
ObjectSetText(lbl[u],lbl2[u],14,"Arial",Green);
n = n+20;
}
*/

   return(0);
  }

//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u],OBJPROP_XDISTANCE,610);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],14,"Courier",dsColor);
n = n+20;

   return(0);
  }

//+------------------------------------------------------------------+
  
void DoWork( string sym, int per )
{

 h = DayOfWeek();

   C = iClose(sym,per,h+1);
   if (DayOfWeek() != 1) {D=iClose(Symbol(),per,1);}
   
   Hi = iHighest(sym,per,MODE_HIGH,6,h+1);
   Li = iLowest(sym,per,MODE_LOW,6,h+1);

prev_high = iHigh(sym,per,Hi);
prev_low = iLow(sym,per,Li);
prev_close = C;

p = (prev_high + prev_low ) / 2 ;// Standard Pivot
p = NormalizeDouble( p, digits ) ;


if(p > close ) { pColor = Lime ; } else {
if(p < close ) { pColor = Red ; } else { pColor = Yellow ; } } 


}  
  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 14, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}

//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

