// tro_tick_ma

#property indicator_separate_window
#property  indicator_buffers 2 
#property  indicator_color1  Lime
#property  indicator_color2  Orange 

/*
#property indicator_minimum 0
#property indicator_maximum 100


#property indicator_level1 80.0
#property indicator_level2 60.0
#property indicator_level3 40.0
#property indicator_level4 20.0
#property indicator_levelcolor DimGray
#property indicator_levelwidth 1
#property indicator_levelstyle 2
*/

extern int myBars   = 1000;
extern int MAperiod = 5;
extern int MAtype   = 1;



//---- indicator buffers 
double     xBuffer[]; 
double     xBuffer1[]; 
double     maBuffer[]; 
double     Buffer[]; 

int      window;  
int      corner;
int      totalLabels;

color  ColorLabels  = Gray;

color  color5 = Red;
color  color4 = Orange;
color  color3 = Yellow;
color  color2 = Green;
color  color1 = Lime;
color  coltrend;

string   labelNames;
string   shortName;

bool sFirst;
double XX;
int ticks = 0 ;
   int limit, pBars; 


//+------------------------------------------------------------------+
int init()
  {

   shortName="Tick by Tick MA(" + MAperiod + ")" ;
   IndicatorShortName(shortName);   

//---- drawing settings 

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); 
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   
//---- indicator buffers mapping 

   SetIndexBuffer(0,xBuffer); 
   SetIndexBuffer(1,xBuffer1);  
   
//---- name for DataWindow and indicator subwindow label 


   SetIndexLabel(0,"tick"); 
   SetIndexLabel(1,"ma"); 

 

ArrayResize(Buffer, myBars) ;
ArrayResize(maBuffer, myBars) ;

ticks = 0 ;
 

limit = myBars - 1 ;

for(int i=limit; i>=0; i--) { Buffer[i] = Close[0] ; xBuffer[i] = Close[0] ; xBuffer1[i] = Close[0] ; maBuffer[i] = Close[0]  ; }
   
   return(0);
  }


//+------------------------------------------------------------------+
int deinit()
  {

   
   ObjectsDeleteAll(window);

   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {
 
window = WindowFind(shortName);        

if(ticks < myBars) { ticks = ticks + 1 ; }

limit = ticks - 1 ;

for(int i=limit; i>=0; i--) { Buffer[i+1] = Buffer[i] ; }

Buffer[0]  = Close[0] ;

  for(i = limit ; i >= 0; i--) 
  { 
   XX          = iMAOnArray(Buffer,ticks,MAperiod,0,MAtype,i); 
   maBuffer[i] = NormalizeDouble(XX, Digits + 1 ) ; 
  } // for

for(  i=limit; i>=0; i--) { xBuffer[i] = Buffer[i] ;  xBuffer1[i] = maBuffer[i] ; }


DoShowLegend() ;
   
       
return(0);
}
  


//+------------------------------------------------------------------+



void DoShowLegend()
{

int       X_trend               =  0; // 360;
int       Y_trend               =  0; // 20;

   corner = 1;
   string sClose = DoubleToStr(iClose(NULL,0,0),Digits) ;
   string symbol = Symbol() ;
   string tHead  = symbol + " " + sClose  ;   
   string tAvg   = "MA(" + MAperiod + ")= " + DoubleToStr(xBuffer1[0] ,Digits + 1)  ;    
   string tik_Val = DoubleToStr(xBuffer[0],Digits) ;
   
   

      if( xBuffer[0]  > xBuffer1[0] ) { coltrend = Lime ;  } else { coltrend = Red ;  }  
 

     
   setObject("tbtma_current1", tHead ,30,08, coltrend ,"Arial Bold" );
   setObject("tbtma_current2", tAvg  ,30,28, coltrend ,"Arial Bold" );  
   
   
/*    
   ObjectCreate("tik_value", OBJ_LABEL, window, 0, 0);
   ObjectSetText("tik_value",tik_Val,30, "Arial Bold", coltrend );   // coltrend Trend_UP
   ObjectSet("tik_value", OBJPROP_CORNER, corner);
   ObjectSet("tik_value", OBJPROP_XDISTANCE, 1000+X_trend-900); // 955+X_trend-900
   ObjectSet("tik_value", OBJPROP_YDISTANCE, 26+Y_trend);    
*/    
}

//+------------------------------------------------------------------+

string next() { totalLabels++; return(totalLabels); }  
//+------------------------------------------------------------------+
void setObject(string name,string text,int x,int y,color theColor, string font = "Arial",int size=10,int angle=0)
{
   string labelName = StringConcatenate(labelNames,name);

      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,window,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,corner);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}

//+------------------------------------------------------------------+

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//+------------------------------------------------------------------+  

/*


 

Comment( 
"myBars=",myBars  , "\n", 
"ticks=", ticks   , "\n",
"XX= ", DoubleToStr(XX,Digits) , "\n",
"Buffer[0]= ", DoubleToStr(Buffer[0],Digits) , "\n",
"xBuffer[0]= ", DoubleToStr(xBuffer[0],Digits) , "\n",
"xBuffer1[0]= ", DoubleToStr(xBuffer1[0],Digits) , "\n",
"maBuffer[0]= ", DoubleToStr(maBuffer[0],Digits) , "\n",
"") ;

Comment(
"ticks= ", ticks, "\n",
"XX= ", DoubleToStr(XX,Digits) , "\n",
"xBuffer[ticks]= ", DoubleToStr(xBuffer[ticks],Digits) , "\n",
"xBuffer[ticks-1]= ", DoubleToStr(xBuffer[ticks-1],Digits) , "\n",
"") ;
 


  for(i = limit ; i >= 0; i--) 
  { 
   XX          = iMAOnArray(xBuffer,Bars,MAperiod,0,MAtype,i); 
   if(Bars >= MAperiod) { xBuffer1[i] = NormalizeDouble(XX, Digits ) ; } else { xBuffer1[i] = Close[i] ; }
  } // for


  if( pBars != Bars ) 
  {
       for(int i=limit; i>=0; i--) { xBuffer[i+1] = xBuffer[i] ; }
 
         pBars            = Bars ;  
       
  }   
  
  
  

for(int i=ticks-1; i>=0; i--) { xBuffer[i+1] = xBuffer[i] ; }
 
xBuffer[0]  = Close[0] ;

if(ticks-1 >= MAperiod)
{ 
  for(i = ticks-1 ; i >= 0; i--) 
  { 
   XX          = iMAOnArray(xBuffer,ticks,MAperiod,0,MAtype,i); 
   xBuffer1[i] = NormalizeDouble(XX, Digits ) ; 
  } // for
}
  
*/