//+------------------------------------------------------------------+
//|                                                         Test.mq4 |
//+------------------------------------------------------------------+
 
double GBPUSD;
double EURUSD;
double AUDUSD;
double USDCAD;
double USDJPY;
 
 
 
double ma[100];
 
bool init = true;
 
 
int start(){
 
 
   while(IsStopped() == false){
      
      // This represents the "indicator", it puts current prices into Comments 5 times/second.
      // and draws a moving average on the base chart
      
      int i;
      for( i = 99; i >= 0; i--){
         ma[i] = iMA(Symbol(), 0, 13, 0, 0, 0, i);
      }
      for( i = 98; i >= 0; i--){
         string name = "ma"+i;
         if(ObjectFind(name) != -1) ObjectDelete(name);
         ObjectCreate(name, OBJ_TREND, 0, Time[i+1], ma[i+1], Time[i], ma[i]);
         ObjectSet(name, OBJPROP_RAY, 0);
         
      }
      
      RefreshRates();
      GBPUSD = MarketInfo("GBPUSD", MODE_BID);
      EURUSD = MarketInfo("EURUSD", MODE_BID);
      AUDUSD = MarketInfo("AUDUSD", MODE_BID);
      USDCAD = MarketInfo("USDCAD", MODE_BID);
      USDJPY = MarketInfo("USDJPY", MODE_BID);
 
      Comment("\n" +
              "Time is "+ TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS) + "  TickTime = " + GetTickCount() + "\n" +
              "GBPUSD = " + GBPUSD + "\n" +
              "EURUSD = " + EURUSD + "\n" +
              "AUDUSD = " + AUDUSD + "\n" +
              "USDCAD = " + USDCAD + "\n" +
              "USDJPY = " + USDJPY + "\n");
      Sleep(200);
   }
   Comment("Script is stopped");
   return(0);
}